#include "Vektor.h"

#include <iostream>
#include <iomanip> // wegen setw
#include <cassert> // wegen assert
using namespace std;

/* Alle Elemente von v1 werden auf wert gesetzt
* v1.daten muss bereits auf den Heap verweisen
*/
void SetValue(Vektor& v1, int wert) {
   for (int i=0; i<v1.dimension; ++i){
      v1.daten[i] = wert;
   }
}
/* Es wird neuer Heapspeicher angefordert und zwar
* fr dim int-Elemente. Sie werden mit wert
* initialisiert.*/
void Init(Vektor& v1, int wert, int dim) {
   v1.dimension = dim;
   v1.daten = new int[dim];
   SetValue(v1, wert);
}

void Free(Vektor& v) {
   delete[] v.daten;
   v.daten = nullptr;
}


void Plus(const Vektor& v1, const Vektor& v2, Vektor& erg) {
   assert(v1.dimension == v2.dimension);
   assert(erg.dimension == v2.dimension);
   erg.dimension = v1.dimension;
   for (int i=0; i<v1.dimension; ++i){
      erg.daten[i] = v1.daten[i] + v2.daten[i];
   }
}

void Print(const Vektor& v1) {
   for (int i=0; i<v1.dimension; ++i){
      cout << setw(4) << v1.daten[i];
   }
}

void Resize(Vektor& v, int newSize) {
   // Mehr Speicher anfordern
   int* tmp  = new int[newSize];
   // bisherigen Inhalt kopieren
   for (int i = 0; i < v.dimension; ++i) {
      tmp[i] = v.daten[i];
   }
   // bisherige Daten freigeben
   delete[] v.daten;
   // tmp auf v.daten umbiegen
   v.daten = tmp;
   v.dimension = newSize;
}
